@echo off
:: MENU.BAT 12/30/95 Gary A. Mays
:: Uses M.EXE, FP.EXE, SELECT.EXE from M405.ZIP or later
:: uses ED.EXE from ED068.ZIP or later
:: another editor can be used, but ed.exe uses the MENU.BAT help file.
:: Last update 9/18/96
  m/set x=[test`[efree]`gt`200]
  if %x%==T goto cont
  m/nul [msgpause`Insufficient environment space, see M.DOC for how to increase it]
  goto quit
:cont
  m/set dir=[directory`]
  set l=
:: ======
:: ====== Set the *full* path to the default starting menu:
:: ======   set menu=D:\util\main
:: ======
:: ====== Or, set a path with trailing \ to get windowed
:: ====== selection of all .MNU files in that path:
:: ======      or: set menu=D:\util\
:: ======          set menu=.\
  set menu=D:\data\main
::  set menu=.\
:: ======
  m/set base=[fpath`[e`menu]]
::
  if %1.==/?. goto help
  if %1.==. goto setmenu
:: if %1 is specified, set menu, then use base path if present
  set menu=%1
:: change base when specified value has a path
  m/set [if`[fpath`[e`menu]]`ne`]base=[fpath`[e`menu]]
:setmenu
  m/set menu=[fonly`[e`menu]]
  if %menu%.==. set menu=*
  if %base%.==.\. m/set base=[directory]
  m/set/halt5 menu=[fonly`[getfilen`[e`base][e`menu].MNU]]
  if errorlevel 5 goto fin
::
  m/set [if`[right`[e`base]`1]`ne`\]base=[e`base]\
:: base now has the directory with trailing \
:: menu has the name of the menu
:: menu.mnu has one or more lines of:
:: Tag,Description,Home directory,Program,Password
:: where:
::   tag = unique tag in this menu to identify the program
::   description = optional description (no punctuation)
::   home directory = changes to this directory (optional) use no trailing \
::   program = command to execute - if .MNU, then switch to that menu
::   password = optional password to run program
:verify  ;existance of menu
  m/set menu=[ucase`%menu%]
  if exist %base%%menu%.MNU goto preselect
  m/nul [msgpause`The menu file %base%%menu%.MNU does not exist]
  goto fin
:preselect
  if exist %base%%menu%.SEL goto select
  cls
  echo Building %base%%menu%.SEL......
  set l=1
m [p`,`[]`t`d`nul`nul][pad`[e`t]`15` ] [e`d]<%base%%menu%.MNU>%base%%menu%.SEL
:select
  cls
  if %l%.==. set l=1
  select /t"%MENU% Menu"/set:s/s1/n/setl:l/g:%l%<%base%%menu%.SEL
  if not errorlevel 5 goto match
:: escape from menu.........
  m/set m=[menu`  Select  `Return to menu`Edit %menu%.MNU`Quit to DOS]
  goto sel_%m%
:sel_
:sel_r
  goto select
:sel_e
  m/set m=[test`[?^Edit Password?``10`5]`eq`edit]
  if %m%==F goto select
  m/set d=[getfages`%base%%menu%.MNU]
  ed %base%%menu%.MNU /h:%base%menu.doc
  m/set t=[getfages`%base%%menu%.MNU]
  if not %d%==%t% erase %base%%menu%.SEL
  goto preselect
:sel_q
  m/set m=[test`[?^Quit Password?``10`5]`eq`quit]
  if %m%==T goto fin
  goto select
:match
:: s has 'tag............description'  where .. represents space fill
:: put tag into t
  m/set t=[c` ``[left`[e`s]`15],]
:: then search menu file for the tag to begin in col 1
  m/set [if`[pos`[e`t]`[c` ``[left`[]`15],]]`eq`1]x=[]<%base%%menu%.MNU
:parseit
:: parse x into tag, [description], [home-directory], program[, password]
:: Program can be more than one command separated with " & " without
:: quotes
  m/nul [p`,`[e`x]`t`d`h`p`w]
  :: First, check if config field specifies a password
  m/set x=[len`%w%]
  if %x%==0 goto exec
  m/set x=[test`[?^Password?]`eq`%w%]
  if errorlevel 5 goto select
  if %x%==T goto exec
  beep
  m/nul [msgdelay`Incorrect password.......`2000]
  goto select
:exec ;a command
  :: change to drive/path of home directory
  if %h%`==` goto exec2
  m/nul [p` `[isdir`[e`h]]`m][if`[not`[e`m]]][msgpause`The HOME directory "[e`h]" does not exist]
  if %m%==T goto home
  m/nul [msgpause`The home directory "[e`h]" does not exist]
  goto select
:home
  :: allows directory with and without trailing \
  m/xqt/q [fdrive`[e`h]]
  m/set [if`[right`[e`h]`1]`ne`\]h=[e`h]\
  cd %h%.
:exec2
  :: parse current command from p into pp
  m/set [parse` & `[e`p]`pp`p]x=[len`[e`pp]]
  if %x%==0 goto preselect
:: cause imbedded macro commands to be processed
  m/set "pp=%pp%"
  if errorlevel 5 goto execcan
  if errorlevel 2 goto execerr
  if errorlevel 1 goto execbad
  goto exec21
:execcan
  m/nul [msgdelay`Canceled`333]
  goto select
:execbad
  m/nul [msgdelay`Syntax error in [e`pp]`20000]
  goto select
:execerr
goto exec21
  call errlev
  m/nul [msg`Errorlevel [e`errorlevel]]
  goto exec21
:exec21
  :: when program is *.MNU and only one word, then process menu
  :: if program is compound, then the menu item must be last
  m/set x=[t`[t`[ftype`[e`pp]]`eq`MNU]`and`[t`[w`[e`pp]`1]`eq`[e`pp]]]
  if %x%==F goto exec22
  :: check for existance of menu - expected to be in the same base path
  m/set x=[test`[fpath`[e`pp]]`eq`]
  if %x%==T goto ufn
m/nul [msgpause`Path in new menu is not allowed ([e`pp]). Path of first menu is used]
  goto preselect
:ufn
  m/set x=[ufn`[e`base][e`pp]]
  if %x%==T goto process
  m/nul [msgpause`The menu file [e`base][e`pp] does not exist]
  goto preselect
:process
  :: process new menu  -  expected to be in the same base path
  m/set menu=[ucase`[fonly`[e`pp]]]
:: next line breaks chain of & commands, so make .MNU item last of
:: a compound command
  set l=
  goto preselect
:exec22
  :: process special commands
  :: example: DOS,Drop to DOS,d:\,COMMAND & pause,password
  m/set x=[test`[w`[e`pp]`1]`in`command`pause`set`erase`copy`cd`quit]
  if %x%==T goto _%pp%
  goto exec3
:: drop to dos:
:_command
%comspec%/e:2048/k PROMPT $_$e[0;1;37;41mEXIT returns to %menu%.MNU$e[0;37;40m$_$e[0;1;33;47m$P$G$e[0;37;40m
  goto exec2
:: set an environment variable
:_set
  :: translate     set farble^stuff  to  m/set farble=stuff
  m/set [c`^`=`[sw`[e`pp]`2]]
  goto exec2
:_pause
:_erase
:_copy
:_cd
  %pp%
  goto exec2
:_quit
:: comment-out next line to quit with verification
  goto fin
  m/set m=[menu`Quit to DOS?`Yes`No]
  if %m%.==Y. goto fin
  goto select
:exec3
  :: execute regular program
  %comspec%/e:2048/c %pp%
  goto exec2
:fin
  set l=
  set s=
  set h=
  set m=
  set x=
  set t=
  set d=
  set w=
  set p=
  set pp=
  set h=
  set menu=
  set base=
  :: restore drive
  m/xqt/q [ss`%dir%`1`2]
  :: restore dir
  cd %dir%.
  set dir=
  echo Type   MENU %1   to re-enter the menu program.....
  goto quit
:help
  fp /n/f/first/set:f menu.doc
  if %f%.==. goto nohelp
  choose /n/t"%f%"<%f% >nul
  set f=
  goto endhelp
:nohelp
  m [msgpause`MENU.DOC is not in any of the PATH directories]
:endhelp
:quit
